#include <fggl/gfx/ogl/backend.hpp>

#include <stdexcept>

using namespace fggl::gfx;

GlGraphics::GlGraphics(const std::shared_ptr<Window> window) : m_window(window) {
    std::cerr << "[OGL] attaching window context" << std::endl;
	window->activate();
	GLenum err = glewInit();
	if ( GLEW_OK != err ) {
		throw std::runtime_error("couldn't init glew");
	}

	glViewport(0, 0, 1920, 1080);
    std::cerr << "[OGL] window ready!" << std::endl;
}

GlGraphics::~GlGraphics() {
    std::cerr << "[GLFW] gl context killed!" << std::endl;
}

void GlGraphics::clear() {
	m_window->activate();

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
}
